/************************************************************
File name: 0_acceleratorCodegenerator.sv

				ACCELERATOR GENERATOR FOR HOST
					
************************************************************/
	
	logic [4:0]				aOpCode			;
	logic [2:0]				aOperand		;
	logic [23:0]			aScalar			;
	logic [4:0]				cOpCode			;
	logic [2:0]				cOperand		;
	logic [23:0]			cScalar			;
	//logic [18:0]			jmpAddr			;
	logic [$clog2(`m)-1:0] 	addrCount 		;
	logic [$clog2(`m)-1:0] 	labTab[0:`m-1]	;
	
	`include "0_DEFINES.vh"
	
	function endLineA();
			dut.HOST.hostDataMemory.hDmem[addrCount] =						
			//dut.accelerator.controller.contrProgMem.
			//contrPM[addrCount] = 			// without host
			{	aOpCode	,	
				aOperand,
				aScalar	,
				cOpCode	,
				cOperand,
				cScalar	}				;
			addrCount	= addrCount + 1	;
	endfunction

	// sets labelTab in the first pass 
	function LB(input logic [5:0] labIndex); 	
		labTab[labIndex] = addrCount; 
	endfunction
	// uses the content of labelTab in the second pass
	//function cULB(input logic [5:0] labIndex); 
	//	cScalar = labTab[labIndex] - addrCount;	
	//endfunction

	function NOP; 
		begin 	aOpCode 	= `add	;
				aOperand 	= `imm	;
				aScalar		= 24'b0	;
				endLineA			;
		end
	endfunction
		
	function cNOP;
		begin 	cOpCode 	= `cadd	;
				cOperand 	= `imm	;
				cScalar		= 24'b0	;
		end
	endfunction
	
	`include "cgCONTROL.sv"		// control instructions 
	`include "cgLOAD.sv"		// load accumulator
	`include "cgSTORE.sv"		// store accumulator
	`include "cgADD.sv"			// addition
	`include "cgADDC.sv"    	// addition with carry
	`include "cgSUB.sv"     	// subtract
	`include "cgSUBC.sv"    	// subtract with carry
	`include "cgMULT.sv"		// multiplication
	`include "cgSHIFT.sv"		// shift
	`include "cgAND.sv"			// bit-wise AND
	`include "cgOR.sv"			// bit-wise OR
	`include "cgXOR.sv"			// bit-wise XOR
	`include "cgREDUCE.sv"		// reduce network functions
	`include "cgGLOBAL.sv"		// global operations
	`include "cgTRANSFER.sv"	// io transfer operations
	`include "cgSEARCH.sv"		// search functions
	//`include "lowLevelLibrary.sv" 
	
	function cSTART;
		begin 	cOpCode 	= `contr			;
				cOperand 	= `imm				;
				cScalar		= {`start, 19'b0}	;
		end
	endfunction
	
	function cSTOP;
		begin 	cOpCode 	= `contr		;
				cOperand 	= `imm			;
				cScalar		= {`stop, 19'b0};
		end
	endfunction
			
	// RUNNING
	initial begin 	addrCount	= 0;
					`include "0_aProgram.sv" // first pass
					addrCount	= 0;
					`include "0_aProgram.sv" // second pass
			end
			