/************************************************************
File: 0_hISA.sv
Name: Host's instruction set architecture

instr={opCode[5:0],dest[4:0],left[4:0],right[4:0],nu[4:0]} |
      {opCode[5:0],dest[4:0],left[4:0],value[15:0]}
reg [31:0] 				rf[0:31]
reg	[$clog2(`m)-1:0] 	pc
reg						cr
************************************************************/
// CONTROL INSTRUCTIONS
`define	nop		6'b000000 // pc <= pc+1
`define jmp     6'b000001 // pc <= pc+value
`define jmpz    6'b000010 // pc <= (rf[left]==0) ? pc+1 : pc
`define jmpnz   6'b000011 // pc <= (rf[left]==0) ? pc : pc+1
`define pfull	6'b000100 
	// pc <= (h2iPfull) ? pc : pc+1 
	// h2iPwrite = 1 
	// host2intProg = rf[left]
`define dempty  6'b000101 
	// pc <= (h2iDempty) ? pc : pc+1 
	// h2iDread = 1 
`define dfull   6'b000110 
	// pc <= (h2iDfull) ? pc : pc+1 
	// h2iDwrite = 1 
`define intwait 6'b000111 // pc <= (int) ? pc+1 : pc
`define ajmp	6'b001000 // pc <= value
`define halt	6'b001001 // pc <= pc

// FUNCTIONAL INSTRUCTIONS
`define add     6'b010000 
	// {cr,rf[dest]} <= rf[left]+rf[right]
`define addcr   6'b010001 
	// {cr,rf[dest]} <= rf[left]+rf[right]+cr
`define sub     6'b010010 
	// {cr,rf[dest]} <= rf[left]-rf[right]
`define subcr   6'b010011 
	// {cr,rf[dest]} <= rf[left]-rf[right]-cr
`define mult    6'b010100 
	// {cr,rf[dest]} <= rf[left]*rf[right]
`define bwand   6'b010101 
	// {cr,rf[dest]} <= {cr, rf[left] & rf[right]}
`define bwor    6'b010110 
	// {cr,rf[dest]} <= {cr, rf[left] | rf[right]}
`define bwxor   6'b010111 
	// {cr,rf[dest]} <= {cr, rf[left] ^ rf[right]}
	
// DATA TRANSFER INSTRUCTIONS		
`define value   6'b111000 
	// {cr,rf[dest]} <= {cr, {{16{value[15}},value}}
`define insval  6'b111001 
	// {cr,rf[dest]} <= {cr, {rf[left][15:0],value}
`define load    6'b111010 
	// {cr,rf[dest]} <= {cr, procDataIn}
`define store   6'b111011 // procWrite = 1
				