/********************************************************************
File: 0_hetSys.sv
Name: Heterogenous System
Description:
********************************************************************/
`include "0_DEFINES.vh"
module hetSys(	input	logic reset	, 
				input	logic clock	);
	logic 			h2iPwrite	; // host to interface program write
	logic 			i2hPfull	; // programFIFO is full
	logic [63:0]	h2i			; // host to data program & data
	logic 			h2iDwrite   ; // host to interface data write
	logic 			i2hDfull    ; // inputDataFIFO is full 
	logic [63:0]	i2h			; // interface to host data
	logic 			h2iDread   	; // host to interface data read
	logic 			i2hDempty  	; // outputDataFIFO is empty	
	logic 			a2hInt		; // accelerator to host interrupt
	logic 			h2aInta		; // interrupt acknowledge
											
	host HOST(	h2iPwrite	,
				i2hPfull	,
				h2i			,
				h2iDwrite   ,
				i2hDfull    ,
				i2h			,
				h2iDread   	,
				i2hDempty   ,
				a2hInt		,
				h2aInta		,
				reset		, 
				clock		);				
	accelerator ACCELERATOR(h2iPwrite	,
							i2hPfull	,
							h2i			,
							h2iDwrite   ,
							i2hDfull    ,
							i2h			,
							h2iDread   	,
							i2hDempty   ,
							a2hInt		,
							h2aInta		,
							reset		, 
							clock		);			
endmodule