`include "0_DEFINES.vh"
module simulator;
	logic	reset, clock;
	
	integer	i			;
	
	initial	begin 				clock = 0		;
					forever	#1 	clock = ~clock	;
			end
			
	hetSys dut(reset, clock);
	
	// INITIALIZE CONTROLLER'S DATA MEMORY
	//initial begin $readmemb("controllerData.txt", dut.MRA.accelerator.controller.dataSection.cMemory.mem);
	//		end
			
	// ASSEMBLER
	`include "0_hostCodeGenerator.sv"	// host's assembler
	`include "0_accCodeGenerator.sv"	// accelerator's assembler
	
	initial begin
		// DISPLAY THE HOST PROGRAM MEMORY
			for (i=0; i<16; i=i+1) 
				$display("hPmem[%0d] \t = %b", 
					i, dut.HOST.hostProgramMemory.hPmem[i]);
		// DISPLAY THE HOST DATA MEMORY
			for (i=0; i<200; i=i+1) 
				$display("hDmem[%0d] \t = %b",
					i, dut.HOST.hostDataMemory.hDmem[i]);
	end
	
	// DYSPLAY CONTROLLER'S DATA MEMORY  
	//initial for (i=0; i<8; i=i+1) $display("dataMemory[%0d] \t = %b", 
	//i, dut.MRA.accelerator.controller.dataSection.cMemory.mem[i])	;
				
	
	//SIMULATION
	initial	begin			
			reset = 1	;
		#4	reset = 0	;
		#60000	begin
			// DISPLAY THE FIRST xx VECTORS OF THE ACCELERATOR
			for (i=0; i<100; i=i+1) 
			$display("vect[%0d]  %d   %d   %d   %d   %d   %d  %d  %d  %d  %d  %d  %d  %d  %d  %d  %d", 
					i, 	dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell1.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell1.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell1.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell1.dataMem.arrayDM[i],
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell1.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell1.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell1.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell0.dataMem.arrayDM[i], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell1.dataMem.arrayDM[i]);
			// DISPLAY THE CONTROLLER PROGRAM MEMORY
			for (i=0; i<16; i=i+1) 
				$display("cPmem[%0d] \t = %b", 
					i, dut.ACCELERATOR.pRISC.controller.contrProgMem.contrPM[i]);
			// DISPLAY THE HOST DATA MEMORY
			for (i=0; i<16; i=i+1)
				$display("hDmem[%0d] \t = %b",
					i, dut.HOST.hostDataMemory.hDmem[i]);
			// DISPLAY THE SCALAR MEMORY OF THE ACCCELERATOR
			//for (i=0; i<10; i=i+1) 
			//		$display("mem[%0d] \t = %b ", 
			//			i, dut.MRA.accelerator.controller.dataSection.cMemory.mem[i]);
		end
 		#4	$finish	;
 	end
	
/*	// MONITOR FOR HOST
	initial begin
		$monitor("t=%0d hpc=%d, i2hDempty=%d, h2i=%b RF=[%d, %d, %d, %d] MEM=[%d, %d, %d, %d, %d, %d, %d,%d, %d, %d, %d%d,%d, %d, %d, %d]",
				$time,  dut.HOST.hostProcessor.hPC.programCounter,
						dut.HOST.hostProcessor.i2hDempty,
						dut.h2i,
						dut.HOST.hostProcessor.hRALU.hRF.hRegFile[0],
						dut.HOST.hostProcessor.hRALU.hRF.hRegFile[1],
						dut.HOST.hostProcessor.hRALU.hRF.hRegFile[2],
						dut.HOST.hostProcessor.hRALU.hRF.hRegFile[3],
						dut.HOST.hostDataMemory.hDmem[8][31:0],		//[0
						dut.HOST.hostDataMemory.hDmem[8][63:32],    //[0
						dut.HOST.hostDataMemory.hDmem[9][31:0],     //[1
						dut.HOST.hostDataMemory.hDmem[9][63:32],    //[1
						dut.HOST.hostDataMemory.hDmem[10][31:0],     //[2
						dut.HOST.hostDataMemory.hDmem[10][63:32],    //[2
						dut.HOST.hostDataMemory.hDmem[11][31:0],     //[3
						dut.HOST.hostDataMemory.hDmem[11][63:32],    //[3
						dut.HOST.hostDataMemory.hDmem[12][31:0],     //[4
						dut.HOST.hostDataMemory.hDmem[12][63:32],    //[4
						dut.HOST.hostDataMemory.hDmem[13][31:0],     //[5
						dut.HOST.hostDataMemory.hDmem[13][63:32],    //[5
						dut.HOST.hostDataMemory.hDmem[14][31:0],     //[6
						dut.HOST.hostDataMemory.hDmem[14][63:32],    //[6
						dut.HOST.hostDataMemory.hDmem[15][31:0],     //[7
						dut.HOST.hostDataMemory.hDmem[15][63:32]);   //[7
	end
//*/	
//*	
	// MONITOR FOR PROGRAM LAOD, CONTROLLER & ARRAY
	initial begin
		$monitor("t=%0d pc=%0d cAcc=%0d aluOut=%b cMEM=[%0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d] index=%0d ACC=[%0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d] SR=[%0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d, %0d] B = [%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d%0d] hCC=%0d, aCC=%0d", 
				$time, 	dut.ACCELERATOR.pRISC.controller.contrProc.progAddr,
						dut.ACCELERATOR.pRISC.controller.contrProc.contAALU.cAcc,
						dut.ACCELERATOR.pRISC.controller.contrProc.contAALU.aluOut,
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[0],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[1],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[2],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[3],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[4],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[5],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[6],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[7],
						dut.ACCELERATOR.pRISC.controller.contrDataMem.contrDM[8],
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell1.exUnit.index,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell1.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell0.exUnit.aAALU.aAcc, 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell1.exUnit.aAALU.aAcc,
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[4].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[4].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[4].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[4].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[5].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[5].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[5].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[5].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[6].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[6].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[6].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[6].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[7].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[7].dc.arrayCell1.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[7].dc.arrayCell0.exUnit.aAALU.aAcc, 
						//dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[7].dc.arrayCell1.exUnit.aAALU.aAcc,						
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell0.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell1.exUnit.serialReg[`n-1:0], 
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[0].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[0].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[1].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[1].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[2].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[2].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col0.cells.DC[3].dc.arrayCell1.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell0.exUnit.aContr.boolean,
						dut.ACCELERATOR.pRISC.array.map.col1.cells.DC[3].dc.arrayCell1.exUnit.aContr.boolean,
						dut.HOST.hostProcessor.hostCycleCounter,
						dut.ACCELERATOR.pRISC.controller.contrProc.contrPC.accCycleCounter);
		end
//*/
endmodule
