/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module arrayAccALU 
		(	input	logic [`n+12:0]			instr		,
			input	logic 					boolean		,
			input	logic [`n-1:0] 			memOut		,
			input	logic [`n-1:0]			serialReg	,
			input	logic [$clog2(`p)-1:0]	index		,
			output	logic [`n-1:0] 			aAcc		,
			output	logic 					aCr			,
			output	logic 					eq			,
			input	logic 					clock		);
					
	logic [`n-1:0]	op		;
	logic [`n:0]	shiftOut;
	
	assign 
		op = (((instr[`n+2:`n] == `imm) || 
			   (instr[`n+2:`n] == `cim)) ? instr[`n-1:0] : 
										   memOut		 );
										   
	assign eq = aAcc == op	;
						
	always_ff @(posedge clock)
	 if (boolean)
		case(instr[`n+7:`n+3])
			`add	: {aCr, aAcc} <= aAcc + op 						;
			`addcr 	: {aCr, aAcc} <= aAcc + op + aCr				;
			`sub   	: {aCr, aAcc} <= aAcc - op      				;
			`subcr 	: {aCr, aAcc} <= aAcc - op - aCr				;
			`mult  	: {aCr, aAcc} <= {aCr, aAcc * op}				;
			`bwand 	: {aCr, aAcc} <= {aCr, aAcc & op}				;
			`bwor  	: {aCr, aAcc} <= {aCr, aAcc | op}				;
			`bwxor 	: {aCr, aAcc} <= {aCr, aAcc ^ op}				;
			`load	: {aCr, aAcc} <= {aCr, op}						;
			`insval	: {aCr, aAcc} <= {aCr, aAcc[23:0], instr[7:0]}	;
			`contr	: case(instr[23:19])
						`getsr	: {aCr, aAcc} <= {aCr, serialReg}						;
						`sradd	: {aCr, aAcc} <= aAcc + serialReg						;
						`ixload	: {aCr, aAcc} <= {aCr, {{`n-$clog2(`p){1'b0}}, index}}	;
						`shift	: {aCr, aAcc} <= {shiftOut}								;
						default	: {aCr, aAcc} <= {aCr, aAcc}							;
					  endcase
			default : {aCr, aAcc} <= {aCr, aAcc}										;	
		endcase;
	
	shiftUnit ashiftUnit(	.shiftOut	(shiftOut	),
							.acc		(aAcc		),
							.cr			(aCr		),
							.shiftCom	(instr[2:0]	));
endmodule