/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module registers (	input	logic [`n+12:0]	instr		,
					input	logic 			noOpInstr	,
					input	logic [31:0]	ioIn		,
					output	logic [31:0] 	ioOut		,
					input	logic [`n-1:0]	memOut		,
					input	logic 			advance		,
					output	logic 			set			,
					output	logic 			rst			,
					output	logic [`n-1:0]	serialReg	,
					input	logic [`n-1:0]	leftIn		,
					input	logic [`n-1:0]	rightIn		,
					input	logic [`n-1:0] 	aAcc		,
					input	logic 			first		,
					input	logic 			next		,
					input	logic 			clock		);					
// IO REGISTER				
	assign set = (instr[`n+7:`n] == {`sendio, `dir}) || (instr[`n+7:`n] == {`sendio, `rei})	;
	assign rst = (instr[`n+7:`n] == {`getio , `dir}) || (instr[`n+7:`n] == {`getio , `rei})	;
	
	always_ff @(posedge clock) begin
		if (instr[`n+7:`n] == {`sendio, `dir}) 	ioOut <= memOut	;
		if (instr[`n+7:`n] == {`sendio, `rei}) 	ioOut <= memOut	;
		if (advance) 				    		ioOut <= ioIn	;
	end	
//SERIAL REGISTER	
	always_ff @(posedge clock) begin
		if ((instr[`n+7:`n] == {`insert, `cim}) || (instr[`n+7:`n] == {`insert, `imm}))
													serialReg <= first ? instr[`n-1:0] : (next ? leftIn : serialReg);
		if ((instr[23:19] == `sendsr) && noOpInstr) serialReg <= aAcc												; 
		if ((instr[23:19] == `delete) && noOpInstr) serialReg <= (first || next) ? rightIn : serialReg 				;
		if (instr[`n+12]) 							serialReg <= instr[`n+11] ? rightIn : leftIn					;
		if (instr[`n+10]) 							serialReg <= instr[`n+8] ? rightIn : leftIn						;
	end		
endmodule