/************************************************************
File: 1_host.sv
Name: Host Computer
Description:
************************************************************/
//`include "0_DEFINES.vh"
module host(output	logic 			h2iPwrite	,		
			input	logic 			i2hPfull	,       
			output	logic [63:0]	h2i			,       
			output	logic 			h2iDwrite   ,       
			input	logic 			i2hDfull    ,       
			input	logic [63:0] 	i2h			,       
			output	logic 			h2iDread   	,       
			input	logic 			i2hDempty   ,       
			input	logic 			a2hInt		,       
			output	logic 			h2aInta		,       
			input	logic 			reset		,       
			input	logic 			clock		);      
	logic [$clog2(`m)-1:0]	hostProgAddr;
	logic [$clog2(`m)-1:0]	hostDataAddr;
	logic [31:0]			instruction	;
	logic [$clog2(`m)-1:0]	transAddr	;
	logic [`n-1:0]			procDataIn	;
	logic [`n-1:0]			procDataOut	;
	logic 					procWrite	;
	logic [$clog2(`m):0]	procAddr	;
	logic [63:0]			mem2int		;
	logic 					selProgOut	;
	logic [63:0]			prog2int	;
	
	assign h2i = selProgOut ? prog2int : mem2int;	
	hostProcessor hostProcessor(h2iPwrite		,
								i2hPfull		,
								mem2int[31:19]	, // to detect : end program transfer
								h2iDwrite   	,
								i2hDfull    	,
								h2iDread   		,
								i2hDempty   	,
								selProgOut		,
								prog2int		,
								hostProgAddr	,
								instruction		,
								transAddr		,
								procDataIn		,
								procDataOut		,
								procWrite		,
								procAddr		,
								a2hInt			,
								h2aInta			,
								reset, clock	);
	hostProgramMemory 
		hostProgramMemory(	.hostProgAddr(hostProgAddr	),
							.hostProgram (0				),
							.we			 (1'b0			),
							.instruction (instruction	),
							.clock		 (clock			));
	hostDataMemory hostDataMemory(	mem2int		,
									i2h			,
									h2iDread   	,
									transAddr	,
									procDataIn	,
									procDataOut	,
									procWrite	,
									procAddr	,
									clock		);
endmodule