/************************************************************
File: 2_hostDataMemory.sv
Name: Host Data Memory
Description:
************************************************************/
module hostDataMemory
		(	output	logic [63:0]			mem2int		,	
			input	logic [63:0] 			i2h			,
			input	logic 					h2iDread   	,
			input	logic [$clog2(`m)-1:0]	transAddr	,
			output	logic [`n-1:0]			procDataIn	,
			input	logic [`n-1:0]			procDataOut	,
			input	logic 					procWrite	,
			input	logic [$clog2(`m):0]	procAddr	,
			input	logic 					clock		);
	logic [63:0] hDmem[0:`m-1]	;
	logic [63:0] procData		;
	
	always_ff @(posedge clock) 
	 if (h2iDread) hDmem[transAddr] <= i2h	; 
	  else if (procWrite) hDmem[procAddr[$clog2(`m):1]] 
			  <= procAddr[0] ? 
					{procDataOut, procData[`n-1:0]} : 
					{procData[63:`n], procDataOut}	;	
	assign mem2int = hDmem[transAddr]	;	
	assign procData = hDmem[procAddr[$clog2(`m):1]]	;
	assign procDataIn = procAddr[0] ? procData[63:`n] : 
									  procData[`n-1:0]	;
endmodule