/************************************************************
File: 2_interfaces.sv
Name: Interfaces
Description:
************************************************************/
//`include "0_DEFINES.vh"
module interfaces(	input	logic 			h2iPwrite	,      
					output	logic 			i2hPfull	,      
					input	logic [63:0]	h2i			,	    
					input	logic 			h2iDwrite   ,      
					output	logic 			i2hDfull    ,      
					output	logic [63:0] 	i2h			,      
					input	logic 			h2iDread   	,      
					output	logic 			i2hDempty   ,      
					output	logic [63:0]	i2aProg		,      
					input	logic 			a2iPread	,      
					output	logic 			i2aPempty	,      
					output	logic [63:0]	i2aData		,      
					input	logic 			a2iDread   	,      
					output	logic 			i2aDempty   ,      
					input	logic [63:0] 	a2i			,      
					input	logic 			a2iDwrite  	,      
					output	logic 			i2aDfull  	,      
					input	logic 			reset, clock);     
                                                            
	fifo programFIFO(	.dataIn	(h2i		),
						.write	(h2iPwrite	),
						.full	(i2hPfull	),
						.dataOut(i2aProg	),
						.read	(a2iPread	),
						.empty	(i2aPempty	),
						.reset	(reset		), 
						.clock	(clock		));	
	fifo inputDataFIFO(	.dataIn	(h2i		),
						.write	(h2iDwrite 	),
						.full	(i2hDfull  	),
						.dataOut(i2aData	),
						.read	(a2iDread   ),
						.empty	(i2aDempty 	),
						.reset	(reset		), 
						.clock	(clock		));	
	fifo outputDataFIFO(.dataIn	(a2i		),
						.write	(a2iDwrite  ),
						.full	(i2aDfull  	),
						.dataOut(i2h		),
						.read	(h2iDread   ),
						.empty	(i2hDempty  ),
						.reset	(reset		), 
						.clock	(clock		));
endmodule

