/************************************************************
File: 3_fifo.sv
Name: FIFO
Description:
************************************************************/
module fifo(input	logic [63:0]	dataIn	,
			input	logic 			write	,
			output	logic 			full	,
			output	logic [63:0]	dataOut	,
			input	logic 			read	,
			output	logic 			empty	,
			input	logic 			reset	, 
			input	logic 			clock	);
	logic [63:0]	ram[0:255]	;
	logic [8:0]	rA, wA		;
	
	assign empty = (rA[7:0] == wA[7:0]) & ~(rA[8] ^ wA[8]);
	assign full =  (rA[7:0] == wA[7:0]) &  (rA[8] ^ wA[8]);	
	always_ff @(posedge clock) 
		if (write && ~full) ram[wA[7:0]] <= dataIn	;	
	assign dataOut = ram[rA[7:0]]	;	
	always_ff @(posedge clock) 
		if (reset) 	begin wA <= 0	;
			              rA <= 0	;
					end
		 else begin	if (write && ~full) wA <= wA + 1;
					if (read && ~empty) rA <= rA + 1;
			  end
endmodule