/************************************************************
File: 3_hostPC.sv
Name: Host Program Counter
Description:
************************************************************/
module hostPC(	
		output	logic 					host2accInta	,
		input	logic 					acc2hostInt		,
		input	logic [12:0]			cInstr			,
		input	logic 					leftEqRigth		,
		input	logic [31:0]			leftOut			,
		output	logic [$clog2(`m)-1:0]	hostProgAddr	,
		input	logic [5:0]				hOpCode			,
		input	logic [$clog2(`m)-1:0]	value			,
		output	logic [31:0]			hostCycleCounter,
		input	logic 					reset			, 
		input	logic 					clock			);				
	logic [$clog2(`m)-1:0] 	programCounter		;
	logic 					hCycleCounterEnable	;
	
	always_ff @(posedge clock) 
	 if (reset)	hostCycleCounter 	<= 0	; 
	  else begin 	
	  	   if (hCycleCounterEnable)	
	  	   	hostCycleCounter 	<= hostCycleCounter + 1	;
	  	   if (hOpCode == `hsttcc) 	
	  	   	hCycleCounterEnable <= 1					;
	  	   if (hOpCode == `hstpcc) 
	  	   	hCycleCounterEnable <= 0					;
	  	   end	
	assign host2accInta = 
			acc2hostInt && (hOpCode == `hintwait)	;	
	always_ff @(posedge clock) 
		if (reset) 	programCounter <= -1			;
			else 	programCounter <= hostProgAddr	;			
	hNextPC hnPC(	hostProgAddr	,
					programCounter	,
					hOpCode			,
					value			,
					acc2hostInt		,
					cInstr			,
					leftEqRigth    	,
					leftOut			);
			
endmodule