/************************************************************
File: 3_hostRALU.sv
Name: Host RALU
Description:
************************************************************/
module hostRALU (	input	logic 			writeEnable	,
					input	logic [4:0]		destAddr	,
					input	logic [4:0]		leftAddr	,
					input	logic [4:0]		rightAddr	,
					input	logic [15:0]	value		,
					input	logic [31:0]	procDataIn	,
					input	logic [5:0]		hFunction	,
					input	logic 			i2hPfull	,
					input	logic 			i2hDfull	,
					input	logic 			i2hDempty	,
					input	logic [1:0]		loadCom		,
					output	logic [31:0]	leftOut		,
					output	logic [31:0]	rightOut	,
					input	logic 			clock		);
	logic [31:0]	result	;
	logic [31:0]	muxOut	;

	hostRegisterFile hRF(	muxOut		,
							writeEnable	,	
							destAddr	,
							leftAddr	,
							rightAddr	,
							leftOut		,
							rightOut	,
							clock		);	
	hostALU hALU(	result		,
					leftOut		,
					rightOut	,
					value		,
					hFunction	,
					i2hPfull	,
					i2hDfull	,
					i2hDempty	,
					clock		);
	hostInMUX hInMux(	.loadCom	(loadCom		),
						.result		(result			),
						.value		(value			),
						.procDataIn	(procDataIn		),
						.leftOutLow	(leftOut[15:0]	),
						.muxOut		(muxOut			));							
endmodule