/************************************************************
File: 3_hostDCD.sv
Name: Host Decoder
Description:
************************************************************/
//`include "0_DEFINES.vh"
module hostDCD (input 	logic [31:0] 	instr		,
				output	logic 			writeEnable	,
				output	logic [1:0]		loadCom		,
				output	logic 			h2iPwrite	,
				output	logic 			h2iDwrite  	,
				output	logic 			h2iDread 	,
				output	logic 			procWrite	,
				output	logic 			selProgOut	,
				output	logic [63:0]	prog2int	);					

	assign writeEnable = (instr[31:30] == 2'b01) ||
						 (instr[31:30] == 2'b10)	;	
	always_comb case(instr[31:26])
					`hvalue	: loadCom = 2'b00;
					`hinsval: loadCom = 2'b01;
					`hload	: loadCom = 2'b10;
					default : loadCom = 2'b11;
				endcase
	assign h2iPwrite 	= 	(instr[31:26] == `hpsend) ||
							(instr[31:26] == `hfsend) ||
							(instr[31:26] == `hssend)	;
	assign selProgOut 	= 	(instr[31:26] == `hfsend) ||
							(instr[31:26] == `hssend)	;
	assign h2iDwrite 	= 	 instr[31:26] == `hdsend	;			
	assign h2iDread  	= 	 instr[31:26] == `hdget		;		
	assign procWrite 	= 	 instr[31:26] == `hstore	;

	assign prog2int = {32'b0, ((instr[31:26] == `hfsend) ? 
		{`contr, `imm, `prun,  instr[18:0]} : 
		{{6{instr[25]}}, instr[25:0]})}					;				
endmodule