/************************************************************
File: 4_controller2distribute.sv
Name: Controller to Array Distribute
Description:
************************************************************/
module controller2distribute(	
		output	logic [`n+12:0]	contr2array	,
		input	logic [31:0]	contrMemIn	,
		input	logic [63:0]	delayedInstr,
		input	logic 	 		clock		);	
	logic [1:0] dsh[0:$clog2(`p)]	;
	logic [1:0] redIns				;
	logic [2:0] shift				;
	integer i	;
	
	assign redIns = 
			((delayedInstr[31:19] == {`contr, `imm, `gshift}) && 
			  delayedInstr[2]) ? 
			{1'b1, delayedInstr[0]} : 2'b00	;
	assign shift = 
			((delayedInstr[31:19] == {`contr, `imm, `gshift}) && 
			  !delayedInstr[2]) ? 
			{1'b1, delayedInstr[1:0]} : 3'b000	;
	always_ff @(posedge clock) for(i=0; i<$clog2(`p)+1; i=i+1)
								dsh[i] <= (i==0) ? redIns : dsh[i-1];							
	assign contr2array = 
		{dsh[$clog2(`p)],
		 shift,
		 delayedInstr[63:56], 
			(((delayedInstr[58:56] == `cim) | 
			  (delayedInstr[58:56] == `cdr) | 
			  (delayedInstr[58:56] == `crl) |
			  (delayedInstr[58:56] == `cri)) ?
				contrMemIn : 
				{{8{delayedInstr[55]}}, delayedInstr[55:32]})};					
endmodule