/************************************************************
File: 4_hNextPC.sv
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module hNextPC 
	   (output	logic [$clog2(`m)-1:0]	hostProgAddr	,
		input	logic [$clog2(`m)-1:0] 	programCounter	,
		input	logic [5:0]				hOpCode			,
		input	logic [$clog2(`m)-1:0]	value			,
		input	logic 					acc2hostInt		,
		input	logic [12:0]			cInstr			,
		input	logic 					leftEqRigth    	,
		input	logic [31:0]			leftOut			);
//*
	always_comb 
		case(hOpCode)
			`hnop	 : hostProgAddr = programCounter + 1	;
			`hjmp	 : hostProgAddr = programCounter + value	;
			`hjmpz	 : hostProgAddr = (leftOut != 0) ? programCounter + value : programCounter + 1				;
			`hjmpnz	 : hostProgAddr = (leftOut == 0) ? programCounter + value : programCounter + 1				;
			`hajmp	 : hostProgAddr = value																		;
			`hpsend	 : hostProgAddr = (cInstr == {`contr, `imm,`prun}) ? programCounter  + 1 : programCounter 	;
			`hdget	 : hostProgAddr = (leftEqRigth) ? programCounter + 1 : programCounter 						;
			`hdsend	 : hostProgAddr = (leftEqRigth) ? programCounter + 1 : programCounter 						;
			`hintwait: hostProgAddr = (acc2hostInt) ? programCounter + 1 : programCounter						;
			`hhalt	 : hostProgAddr = programCounter															;
			default  : hostProgAddr = programCounter + 1														;
		endcase
//*/					
endmodule