/************************************************************
File: 4_reduce.sv
Name: Reduce Network
Description:
************************************************************/
module reduce #(parameter P=`p)(
		output	logic [`n+1:0]	red2contr			,
		input	logic [`n+1:0]	map2reduce[0:P-1]	,
		input	logic 			clock				);
   logic [`n+1:0]   out0, out1  ;

   genvar   i   ;
   generate
    if (P == 2) eRed    ered	(	map2reduce[0:1] ,
									red2contr 		,
									clock   		);
     else begin 
		reduce #(.P(P/2))
			reduce0(.red2contr 	(out0       		),
					.map2reduce	(map2reduce[P/2:P-1]),
					.clock  	(clock      		)),
			reduce1(.red2contr 	(out1       		),
					.map2reduce	(map2reduce[0:P/2-1]),
					.clock  	(clock      		));
        eRed ereduce(	.in    	({out0, out1}   	),
						.out    (red2contr      	),
						.clock  (clock          	));
      end
   endgenerate
endmodule