/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module column(	
		input	logic [63:0]		int2accData			,
		output	logic [63:0] 		acc2intData			,
		input	logic [2:0]			dataTransCom		,
		output	logic [`n+1:0] 		map2reduce[0:`p/2-1],
		output	logic [0:`p/2-1]	boolean				,
		input	logic [0:`p/2-1]	first				,
		input	logic [0:`p/2-1]	next				,
		output	logic [`n:0]		rightOut[0:`p/4-1]	,
		input	logic [`n:0]		leftIn[0:`p/4-1]	,
		output	logic [`n-1:0]		leftOut[0:`p/4-1]	,
		input	logic [`n-1:0]		rightIn[0:`p/4-1]	,
		input	logic [`n+12:0]		contr2array			,
		output	logic [1:0]			rotateSelLeft		,
		output	logic [1:0]			rotateSelRight		,
		input	logic 				index				,
		input	logic 				clock				);
//*				
	logic [`n+12:0]	fromDistr[0:`p/4-1]	;
	logic [1:0]		rsl					;
	logic [1:0]		rsr					;
	
	always_ff @(posedge clock) begin 
		rsl				<= fromDistr[0][`n+12] ? 2'b10 : {1'b0, fromDistr[0][`n+9]}				;
		rotateSelLeft	<= rsl																	;
		rsr				<= fromDistr[`p/4-1][`n+12] ? 2'b10 : {1'b0, fromDistr[`p/4-1][`n+9]}	;
		rotateSelRight  <= rsr																	;
		end
	
	distribute distribute(	contr2array	,
							fromDistr	,
							clock		);
	
	cells cells(int2accData	,
				acc2intData	,
				dataTransCom,
				map2reduce	,
				boolean		,
				first		,
				next		,
				rightOut	,
				leftIn		,
				leftOut		,
				rightIn		,
				fromDistr	,
				index		,
				clock		);
//*/				
endmodule