/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module controllerAALU(	
		input	logic [31:0]	instruction	,
		input	logic [31:0]	contrMemOut	,
		input	logic [`n-1:0]	red2contr	,
		input	logic [31:0]	int2accProg	,
		output	logic [31:0]	cAcc		,
		output	logic 			zero		,
		input	logic 			clock		);	
	logic [31:0]	aluOut	;
	logic 			cCrOut	;
	logic 			cCr		;
	logic 			wb		;
	
	controllerALU cALU(	.aluOut		(aluOut				),
						.wb			(wb					),
						.cCrIn		(cCr				),
						.func		(instruction[31:19]	),
						.int2accProg(int2accProg		),
						.value		(instruction[23:0]	),
						.cAcc		(cAcc				),
						.red2contr	(red2contr			),
						.contrMemOut(contrMemOut		),
						.cCrOut		(cCrOut				));			
	always_ff @(posedge clock)	
		if (wb) begin	cAcc <= aluOut	;
						cCr  <= cCrOut	;
				end						
	assign	zero = (aluOut == 32'b0) ;
endmodule