/************************************************************
File:
Name:
Description:
************************************************************/
module controllerPC(	
		output	logic [$clog2(`m)-1:0]	progAddr	,
		input	logic [31:0]			instr		,
		input	logic 					zero		,
		input	logic 					endTransfer	,
		input	logic [1:0]				accState	,
		input	logic 					initFunc	,
		input	logic [$clog2(`m)-1:0]	initAddr	,
		input	logic 					reset, clock);
	logic [$clog2(`m)-1:0]	cPC				;
	logic [31:0]			accCycleCounter	;
	logic [1:0]				selNPC			;	
	
	always_ff @(posedge clock) 
		if (reset)																cPC <= -1			;
		 else if (accState == `running)											cPC <= progAddr		;
				else if (initFunc)												cPC <= initAddr - 1	;
						else if ((accState == `loading) || (accState == `idle)) cPC <= -1			;
	
	controllerNextPc cNPc(	.progAddr		(progAddr				),
							.controllerPC	(cPC					),	
							.value			(instr[$clog2(`m)-1:0]	),
							.selNPC			(selNPC					));
	
	controllerNextPcDec cNPD(	selNPC		,
								instr		,
								zero		,
								endTransfer	);
								
	logic aCycleCounterEnable	;
	
	always_ff @(posedge clock) 
		if (reset)	begin	accCycleCounter 	<= 0	;
							aCycleCounterEnable <= 0	;
					end
			else begin 	if (aCycleCounterEnable) accCycleCounter <= accCycleCounter + 1		;
						if (instr[31:19] == {`contr, `imm, `start})	aCycleCounterEnable <= 1;
						if (instr[31:19] == {`contr, `imm, `stop })	aCycleCounterEnable <= 0;
				 end
endmodule