//`include "0_DEFINES.vh"
module orPrefix #(parameter m=1,P=`p)(	
		input 	logic [0:P-1] in	,
		output	logic [0:P-1] out	);

    logic [0:P-1] 	inRowOut;
    logic [0:P/2-1] halfIn 	;
    logic [0:P/2-1] halfOut	;

    genvar i    ;
    generate
    if (P == 2) pxCell  Cell(   .out	(out[0:1]   ),
                                .in 	(in[0:1]    ));
     else begin
        for(i=0; i<P/2; i=i+1)  begin: inCell
            pxCell  inCell(.out(inRowOut[2*i:2*i+1] ),
                        .in (in[2*i:2*i+1]          ));
            end
        for(i=0; i<P/2; i=i+1)
            assign halfIn[i] = inRowOut[2*i+1] ;
        orPrefix #(.P(P/2))   halfPrefix(.out(halfOut),
                                        .in (halfIn ));
        assign  out[0] = inRowOut[0]   ;
        for(i=0; i<(P/2)-1; i=i+1)  begin: outCell
         pxCell
            outCell(.out(out[2*i+1:2*i+2]               ),
                    .in ({halfOut[i], inRowOut[2*(i+1)]}));
                end
        assign out[P-1] = halfOut[P/2-1]    ;
     end
    endgenerate
endmodule

		
							