/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module cells
	   (input	logic [63:0]		int2accData			,
		output	logic [63:0] 		acc2intData			,
		input	logic [2:0]			dataTransCom		,
		output	logic [`n+1:0] 		map2reduce[0:`p/2-1],
		output	logic [0:`p/2-1]	boolean				,
		input	logic [0:`p/2-1]	first				,
		input	logic [0:`p/2-1]	next				,
		output	logic [`n:0]		rightOut[0:`p/4-1]	,
		input	logic [`n:0]		leftIn[0:`p/4-1]	,
		output	logic [`n-1:0]		leftOut[0:`p/4-1]	,
		input	logic [`n-1:0]		rightIn[0:`p/4-1]	,
		input	logic [`n+12:0]		fromDistr[0:`p/4-1]	,
		input	logic 				index				,
		input	logic 				clock				);		
// dataTransCom : 000 : nop
// dataTransCom : 100 : even insert
// dataTransCom : 101 : odd insert
// dataTransCom : 110 : even extract
// dataTransCom : 111 : odd extract
	logic [63:0]	ioReg[0:`p/4]		;	
	logic 			prevState[0:`p/4-1]	;
	logic       	nextState[0:`p/4-1]	;
	logic       	state[0:`p/4-1]		;
	
	assign ext 	= &dataTransCom[2:1] ? 
					dataTransCom[0] : 1'b1	;
	assign ins	= dataTransCom == 3'b101	;
	
	assign acc2intData 	= ioReg[0]	;
	
	genvar   i	;
	generate
	for(i=0; i<`p/4; i=i+1)  begin: DC
	dualCell dc(
	 .ioIn		((i==`p/4-1) ? int2accData : ioReg[i+1]	),
	 .ioOut		(ioReg[i]								), 
	 .prevState	((i==`p/4-1) ? ins : state[i+1]			),
	 .nextState	((i==0) ? ext : state[i-1]				),
	 .state		(state[i]								),
	 .map2reduce(map2reduce[2*i:2*i+1]					),
	 .boolean	(boolean[2*i:2*i+1]						),
	 .first		(first[2*i:2*i+1]						),
	 .next		(next[2*i:2*i+1]						),
	 .rightOut	(rightOut[i]							),
	 .leftIn	(leftIn[i]								),
	 .leftOut	(leftOut[i]								),
	 .rightIn	(rightIn[i]								),
	 .fromDistr	(fromDistr[i]							),
	 .index		({i, index}								),
	 .clock		(clock									));
	end
	endgenerate			
endmodule 