 /************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module controllerALU(	output	logic [31:0]	aluOut		,
						output	logic 			wb			,
						input	logic 			cCrIn		,
						input	logic [12:0]	func		,
						input	logic [31:0]	int2accProg	,
						input	logic [23:0]	value		,
						input	logic [31:0]	cAcc		,
						input	logic [`n-1:0]	red2contr	,
						input	logic [31:0]	contrMemOut	,
						output	logic 			cCrOut		);					
//*
	logic [31:0]	op		;
	logic [1:0]		opSel	;
	logic [32:0]	shiftOut;
	logic [32:0]	sum		;
	logic [32:0]	dif		;
	
	assign sum = cAcc + op	;
	assign dif = cAcc - op	;
	
	assign opSel = (func[12:5] == {`cinsval, `imm}) ? 	2'b10 :
					((func[7:5] == {`cim}) ? 			2'b11 :
					 ((func[7:5] == `imm) ? 			2'b01 : 
														2'b00))	;
	
	//always_comb	
	// case(func[7:0])
	// 	{`cinsval, `imm}: 			opSel = 2'b10;
	// 	{`contr, `imm, `redload}: 	opSel = 2'b11;
	// 	default: 					opSel = (func[2:0] == `imm) ? 2'b01 : 2'b00;
	// endcase
	 
	 always_comb case(opSel)
					2'b00: op =	contrMemOut				; 
					2'b01: op =	{{8{value[23]}}, value}	; 
					2'b10: op =	{cAcc[23:0], value[7:0]}; 
					2'b11: op =	red2contr				; 
				endcase
						
	always_comb  
	 case(func[12:8])
	 	`cadd	: {wb, cCrOut, aluOut} = {1'b1, sum} 				;   
	    `caddcr : {wb, cCrOut, aluOut} = {1'b1, sum + cCrIn}		;
	    `csub   : {wb, cCrOut, aluOut} = {1'b1, dif} 				;
	    `csubcr : {wb, cCrOut, aluOut} = {1'b1, dif - cCrIn}		;
	    `cmult  : {wb, cCrOut, aluOut} = {1'b1, cCrIn, cAcc * op}	;
	    `cbwand : {wb, cCrOut, aluOut} = {1'b1, cCrIn, cAcc & op}	;
	    `cbwor  : {wb, cCrOut, aluOut} = {1'b1, cCrIn, cAcc | op}	;
	    `cbwxor : {wb, cCrOut, aluOut} = {1'b1, cCrIn, cAcc ^ op}	;
	    `cload  : {wb, cCrOut, aluOut} = {1'b1, cCrIn, op}			;
		`cinsval: {wb, cCrOut, aluOut} = {1'b1, cCrIn, op}			;
		`contr	: case(func[4:0])
					`brzdec	: {wb, cCrOut, aluOut} = {1'b1, cCrIn, cAcc - 1'b1} ; 
					`brnzdec: {wb, cCrOut, aluOut} = {1'b1, cCrIn, cAcc - 1'b1}	;
					`param	: {wb, cCrOut, aluOut} = {1'b1, cCrIn, int2accProg}	;
					`cshift	: {wb, cCrOut, aluOut} = {1'b1, shiftOut}			;
					default	: {wb, cCrOut, aluOut} = {2'b0, aluOut}				;
				  endcase	    
		default	: {wb, cCrOut, aluOut} = {2'b0, aluOut}							;
	 endcase
	 
	shiftUnit cshiftUnit(	.shiftOut	(shiftOut	),
							.acc		(cAcc		),
							.cr			(cCrIn		),
							.shiftCom	(value[2:0]	));
//*/	
endmodule