/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module controllerNextPcDec(	
		output 	logic [1:0]		selNPC		,
		input	logic [31:0]	instr		,
		input	logic 			zero		,
		input	logic 			endTransfer	);	
//	00: pc+1
//	01: pc+val
//	10: val
//	11: pc
	always_comb  
	 if (instr[31:24] == {`contr, `imm})
	  case(instr[23:19])
	   `nop   	: selNPC = 2'b00						; 	
	   `jmp   	: selNPC = 2'b01						;
	   `brz  	: selNPC = zero ? 2'b01 : 2'b00			;	
	   `brnz 	: selNPC = zero ? 2'b00 : 2'b01			;
	   `brzdec  : selNPC = zero ? 2'b01 : 2'b00			;	
	   `brnzdec : selNPC = zero ? 2'b00 : 2'b01			;   
	   `ajmp  	: selNPC = 2'b10 						;
	   `halt  	: selNPC = 2'b11						;
	   `datains	: selNPC = endTransfer ? 2'b00 : 2'b11	;
	   `dataext	: selNPC = endTransfer ? 2'b00 : 2'b11	;
	   default 	: selNPC = 2'b00						;
	  endcase	
	 else		  selNPC = 2'b00						;				   									
endmodule

