/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module shiftUnit (	output	logic [32:0]	shiftOut,
					input	logic [31:0]	acc		,
					input	logic 			cr		,
					input	logic [2:0]		shiftCom);			
	always_comb 
	  case(shiftCom)
	  	3'b000 : shiftOut = {cr, acc}						; // NOP
	  	3'b001 : shiftOut = {acc[31], acc[30:0], 1'b0	 }	; // SHL
	  	3'b010 : shiftOut = {acc[31], acc[30:0], cr	 	 }	; // SHLC
	  	3'b011 : shiftOut = {acc[31], acc[30:0], acc[31] }	; // ROTL
	  	3'b100 : shiftOut = {acc[0], 1'b0, 		acc[31:1]}	; // SHR
	  	3'b101 : shiftOut = {acc[0], acc[31],	acc[31:1]}	; // ASHR
	  	3'b110 : shiftOut = {acc[0], cr, 		acc[31:1]}	; // SHRC
	  	3'b111 : shiftOut = {acc[0], acc[0], 	acc[31:1]}	; // ROTR
	  endcase					
endmodule