/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module arrayCell (	
		input	logic [`n+12:0]			instr		,
		input	logic 					noOpInstr	,
		input	logic [$clog2(`m)-1:0]	readAddr	,
		input	logic [7:0]             readCom		,
		input	logic [31:0]			ioIn		,
		output	logic [31:0] 			ioOut		,
		input	logic 					advance		,
		output	logic 					set			,
		output	logic 					rst			,
		output	logic [`n+1:0] 			map2reduce	,
		output	logic 					boolean		,
		input	logic 					first		,
		input	logic 					next		,
		output	logic [`n:0]			serialReg	,
		input	logic [`n:0]			leftIn		,
		input	logic [`n-1:0]			rightIn		,
		input	logic [$clog2(`p)-1:0]	index		,
		input	logic 					clock		);
//*					
	logic [`n-1:0] memOut	;
	logic [`n-1:0] aAcc		;
	
	arrayDataMemory dataMem(	
		.arrayDataAddr		(readAddr				),
		.arrayDelDataAddr	(instr[$clog2(`m)-1:0]	),
		.arrayMemOut		(memOut					),
		.arrayMemIn0		(aAcc					),
		.arrayMemIn1		(ioOut					),
		.arrayMemCom		(readCom				),
		.arrayDelMemCom		(instr[`n+7:`n]			),
		.noOpCode			(instr[23:19]			),
		.noOpInstr			(noOpInstr				),
		.boolean			(boolean				),
		.clock				(clock					));
		
	executeUnit exUnit(	instr		,
						noOpInstr	,
						index		,
						ioIn		,
						ioOut		,
						advance		,
						set			,
						rst			,
						map2reduce	,
						boolean		,
						first		,
						next		,
						serialReg	,
						leftIn		,
						rightIn		,
						memOut		,
						aAcc		,
						clock		);
//*/
endmodule