/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module propAutom(   
		output  logic com   	, // load  the local register
		output  logic state 	, // the local state of the cell
		input   logic set   	, // set cell state on "full"  
		input   logic rst   	, // set cell state in "empty" 
		input   logic prevState , // state of the previous cell
		input   logic nextState , // state of the next cell
		input   logic clock 	);

    assign com = ~state & prevState;

    always_ff @(posedge clock)
        if (rst)         state <= 0;
          else if (set)  state <= 1;
                 else    state <= ~state & prevState | state & nextState;
endmodule