/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module arrayDataMemory (	
		input	logic [$clog2(`m)-1:0] 	arrayDataAddr	,
		input	logic [$clog2(`m)-1:0] 	arrayDelDataAddr,
		output	logic [`n-1:0]			arrayMemOut		,
		input	logic [`n-1:0]			arrayMemIn0		,
		input	logic [`n-1:0]			arrayMemIn1		,
		input	logic [7:0]				arrayMemCom		,
		input	logic [7:0]				arrayDelMemCom	,
		input	logic [4:0]				noOpCode		,
		input	logic 					noOpInstr		,
		input	logic 					boolean			,
		input	logic 					clock			);
// memCom: 00:nop; 01:absolute; 10:relative; 11:relative+update
//*
	logic [`n-1:0]			arrayDM[0:`m-1]	;
	logic [$clog2(`m)-1:0] 	arrayAddrReg	;
	logic [1:0]				wCom            ;
	logic [1:0]				rCom            ;
	logic [$clog2(`m)-1:0]	wAddr			;
	logic [$clog2(`m)-1:0]	rAddr			;
	logic 					addrLoad		;
	logic [`n-1:0]			memIn			;
// Transcode: 
//memCom: 00:nop; 01:abs; 10:rel; 11:rel+update
	always_comb if ((arrayDelMemCom[7:3] == `store) ||
					(arrayDelMemCom[7:3] == `getio))
					case(arrayDelMemCom[2:0])
						{`dir}: wCom = 2'b01;
						{`cdr}: wCom = 2'b01;  
						{`rel}: wCom = 2'b10;
						{`crl}: wCom = 2'b10;
						{`rei}: wCom = 2'b11;
						{`cri}: wCom = 2'b11;
				     default: 	wCom = 2'b00;
					endcase
				 else 			wCom = 2'b00;
	always_comb if ((arrayMemCom[7:3] == `store) ||
					 (arrayMemCom[7:3] == `getio))
									rCom = 2'b00;
				  else 	case(arrayMemCom[2:0])
							`dir: 	rCom = 2'b01;
							`cdr: 	rCom = 2'b01;
							`rel: 	rCom = 2'b10;
							`crl: 	rCom = 2'b10;
							`rei: 	rCom = 2'b11;
							`cri: 	rCom = 2'b11;
							default:rCom = 2'b00;
						endcase
	assign addrLoad = (`arela == noOpCode) && noOpInstr	;	
// Address compute
	always_comb	
		case(wCom)
			2'b01: wAddr = arrayDelDataAddr					;
			2'b10: wAddr = arrayAddrReg + arrayDelDataAddr	;
			2'b11: wAddr = arrayAddrReg + arrayDelDataAddr	;
		  default: wAddr = arrayDelDataAddr					;
		endcase
				
	always_comb	case(rCom)
					2'b01: rAddr = arrayDataAddr				;
					2'b10: rAddr = arrayAddrReg + arrayDataAddr	;
					2'b11: rAddr = arrayAddrReg + arrayDataAddr	;
				  default: rAddr = arrayDataAddr				;
				endcase
// Operation
	assign memIn = (arrayDelMemCom[7:3] == `getio) ? arrayMemIn1 : arrayMemIn0	;

	always_ff @(posedge clock)	if (boolean)
	begin	
		if (|rCom) 		arrayMemOut 	<= arrayDM[rAddr]					;
		if (|wCom) 		arrayDM[wAddr] 	<= memIn							;
		if (&wCom) 		arrayAddrReg 	<= arrayAddrReg + arrayDelDataAddr	;
		if (&rCom) 		arrayAddrReg 	<= arrayAddrReg + arrayDataAddr		;
		if (addrLoad) 	arrayAddrReg 	<= arrayMemIn0[$clog2(`m)-1:0]		;
	end
//*/	
endmodule