/************************************************************
File:
Name:
Description:
************************************************************/
//`include "0_DEFINES.vh"
module executeUnit 
		(	input	logic [`n+12:0]			instr		,
			input	logic 					noOpInstr	,
			input	logic [$clog2(`p)-1:0]	index		,
			input	logic [31:0]			ioIn		,
			output	logic [31:0] 			ioOut		,
			input	logic 					advance		,
			output	logic 					set			,
			output	logic 					rst			,
			output	logic [`n+1:0] 			map2reduce	,
			output	logic 					boolean		,
			input	logic 					first		,
			input	logic 					next		,
			output	logic [`n:0]			serialReg	,
			input	logic [`n:0]			leftIn		,
			input	logic [`n-1:0]			rightIn		,
			input	logic [`n-1:0] 			memOut		,
			output	logic [`n-1:0] 			aAcc		,
			input	logic 					clock		);				
	logic 		aCr		;
	logic [1:0]	redFunc	;
	logic 		eq		;
	
	assign serialReg[`n] = boolean	; 
	assign map2reduce = {redFunc, aAcc}	;
	
	aControl aContr(.instr		(instr			),
					.aAcc		(aAcc			),
	                .aCr		(aCr			),
					.boolean	(boolean		),
					.leftBool	(leftIn[`n]		),
					.first		(first			),
					.next		(next			),
					.redFunc	(redFunc		),
					.eq			(eq				),
					.clock		(clock			));	
					
	arrayAccALU aAALU(	instr				,
						boolean				,
						memOut				,
						serialReg[`n-1:0]	,
						index				,
						aAcc				,
						aCr					,
						eq					,
						clock				);
	
	registers regs(	.instr		(instr				),
					.noOpInstr	(noOpInstr			),
					.ioIn		(ioIn				),
					.ioOut		(ioOut				),
					.memOut		(memOut				),
					.advance	(advance			),
					.set		(set				),
					.rst		(rst				),
					.serialReg	(serialReg[`n-1:0]	),
					.leftIn		(leftIn[`n-1:0]		),
					.rightIn	(rightIn			),
					.aAcc		(aAcc				),
					.first		(first				),
					.next		(next				),
					.clock		(clock				));				
endmodule