// in CONTROLLER
	function cHALT;
		cOpCode 	= `contr		;
		cOperand 	= `imm			;
		cScalar		= {`halt, 19'b0};
	endfunction
	
	function cJMP(input logic [9:0] lab);
		logic [18:0] jmpAddr;
		
		jmpAddr = labTab[lab] - addrCount	;
		cOpCode 	= `contr				;
		cOperand 	= `imm					;
		cScalar		= {`jmp, jmpAddr}		;
	endfunction
	
	function cAJMP(input logic [18:0] value);
		cOpCode 	= `contr				;
		cOperand 	= `imm					;
		cScalar		= {`ajmp, value}		;	
	endfunction
	
	function cBRNZ(input logic [9:0] lab)	;
		logic [18:0] jmpAddr;
		
		jmpAddr = labTab[lab] - addrCount	;
		cOpCode 	= `contr				;
		cOperand 	= `imm					;
		cScalar		= {`brnz, jmpAddr}		;	
	endfunction
	
	function cBRZ(input logic [9:0] lab);	
		logic [18:0] jmpAddr;
		
		jmpAddr = labTab[lab] - addrCount	;
		cOpCode 	= `contr				;
		cOperand 	= `imm					;
		cScalar		= {`brz, jmpAddr}		;
	endfunction
	
	function cBRNZDEC(input logic [9:0] lab);	
		logic [18:0] jmpAddr;
		
		jmpAddr = labTab[lab] - addrCount	;
		cOpCode 	= `contr				;
		cOperand 	= `imm					;
		cScalar		= {`brnzdec, jmpAddr}	;	
	endfunction
	
	function cBRZDEC(input logic [9:0] lab)	;	
		logic [18:0] jmpAddr;
		
		jmpAddr = labTab[lab] - addrCount	;
		cOpCode 	= `contr				;
		cOperand 	= `imm					;
		cScalar		= {`brzdec, jmpAddr}	;	
	endfunction
	
//in ARRAY
	function ACTIVATE;
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`allact, 19'b0}	;
		endLineA						;
	endfunction

	function WHEREZERO; // where acc[i] = 0
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0000};
		endLineA						;
	endfunction
	
	function WHERECARRY; // where carry
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0001};
		endLineA						;
	endfunction
	
	function WHERENEGATIVE; // where negative
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0010};
		endLineA						;
	endfunction
	
	function WHEREPREVACT; // where previous is active
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0011};
		endLineA						;
	endfunction
	
	function WHEREFIRST; // where first
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0100};
		endLineA						;
	endfunction
	
	function WHERENEXT; // where next to first
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0101};
		endLineA						;
	endfunction
	
	function WHEREPREV; // where previous to first
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b0110};
		endLineA						;
	endfunction
	
	function WHERENZERO; // where acc[i] != 0
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1000};
		endLineA						;
	endfunction
	
	function WHERENCARRY; // where not carry
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1001};
		endLineA						;
	endfunction
	
	function WHEREPOSITIVE; // where positive
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1010};
		endLineA						;
	endfunction
	
	function WHERENPREVACT; // where previous is active
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1011};
		endLineA						;
	endfunction
	
	function WHERENFIRST; // where not first
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1100};
		endLineA						;
	endfunction
	
	function WHERENNEXT; // where not next to first
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1101};
		endLineA						;
	endfunction
	
	function WHERENPREV; // where not previous to first
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`where, 19'b1110};
		endLineA						;
	endfunction
	
	function ELSEWHERE; // else where
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`elsew, 19'b0000};
		endLineA						;
	endfunction
	
	function ENDWHERE;	// end where
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`back, 19'b0000}	;
		endLineA						;
	endfunction
	
	function SELSHIFT;	// selections shift one position right
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`selsh, 19'b0000};
		endLineA						;
	endfunction
	