// in CONTROLLER
	// global right shift with one positio; sr[0] <= 0
	function cGRSHIFT; 	
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`gshift, 19'b000};
	endfunction
	
	// global left shift with one position; sr[p-1] <= 0
	function cGLSHIFT; 	
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`gshift, 19'b001};
	endfunction
	
	// global right rotate with one position
	function cGRROTATE; 
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`gshift, 19'b010};
	endfunction
	
	// global left rotate with one position
	function cGLROTATE; 
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`gshift, 19'b011};
	endfunction
	
	// insert left redOut in shift register
	function cLREDINS; 
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`gshift, 19'b100};
	endfunction
	
	// insert right redOut in shift 
	function cRREDINS; 
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`gshift, 19'b101};
	endfunction
	
// in ARRAY
	// insert value in the first active position
	function INSERT(input logic [23:0] value);
		aOpCode 	= `insert	;
		aOperand 	= `imm		;
		aScalar		= value		;	
		endLineA				;
	endfunction
	
	// insert co-operand in the first active position
	function  CINSERT; 		
		aOpCode 	= `insert	;
		aOperand 	= `cim		;
		aScalar		= 24'b0		;
		endLineA				;
	endfunction
	
	// delete the first active accumulator
	function DELETE; 
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`delete, 19'b0}	;
		endLineA						;
	endfunction
	

	