// in CONTROLLER
	// addr <= acc
	function cADDRLD; 
		cOpCode 	= `contr			;
		cOperand 	= `imm				;
		cScalar		= {`crela, 19'b0}	;
	endfunction
		
	// store acc at contrScalar
	function cSTORE(input logic [9:0] value);	
		cOpCode 	= `cstore	;
		cOperand 	= `dir		;
		cScalar		= value		;
	endfunction
		
	// store acc at addr + contrScalar
	function cRSTORE(input logic [9:0] value);
		cOpCode 	= `cstore	;
		cOperand 	= `rel		;
		cScalar		= value		;
	endfunction
		
	// store acc at addr + contrScalar
	// addr <= addr + contrScalar
	function cRISTORE(input logic [9:0] value);
		cOpCode 	= `cstore	;
		cOperand 	= `rei		;
		cScalar		= value		;
	endfunction
	
// in ARRAY
	// store acc[i] at arrayScalar
	function STORE(input logic [23:0] value);	
		aOpCode 	= `store;
		aOperand 	= `dir	;
		aScalar		= value	;
		endLineA			;
	endfunction
	
	// store acc[i] at addr[i] + arrayScalar
	function RSTORE(input logic [23:0] value);
		aOpCode 	= `store;
		aOperand 	= `rel	;
		aScalar		= value	;
		endLineA			;
	endfunction
	
	// store acc[i] at addr[i] + arrayScalar
	// addr[i] <= addr[i] + contrScalar
	function RISTORE(input logic [23:0] value);	
		aOpCode 	= `store;
		aOperand 	= `rei	;
		aScalar		= value	;
		endLineA			;
	endfunction
	
	// store acc[i] at  acc
	function CSTORE; 		
		aOpCode 	= `store;
		aOperand 	= `cdr	;
		aScalar		= 24'b0	;
		endLineA			;
	endfunction
	
	// store acc[i] at addr[i] + acc
	function CRSTORE; 	
		aOpCode 	= `store;
		aOperand 	= `crl	;
		aScalar		= 24'b0	;
		endLineA			;
	endfunction
	
	// store acc[i] at addr[i] + acc
	// addr[i] <= addr[i] + acc
	function CRISTORE; 		
		aOpCode 	= `store;
		aOperand 	= `cri	;
		aScalar		= 24'b0	;
		endLineA			;
	endfunction
	
	// addr[i] <= acc[i]
	function ADDRLD; 	
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`arela, 19'b0}	;
		endLineA						;
	endfunction
	
	// ioReg[i] <= aMem[value]; ioSet
	function SENDIO(input logic [23:0] value);		
		aOpCode 	= `sendio	;
		aOperand 	= `dir		;
		aScalar		= value		;
		endLineA				;
	endfunction	
	
	// ioReg[i] <= aMem[value + arrayAddrReg]; ioSet
	function RISENDIO(input logic [23:0] value);		
		aOpCode 	= `sendio	;
		aOperand 	= `rei		;
		aScalar		= value		;
		endLineA				;
	endfunction		
	
	// serialReg[i] <= acc[i]
	function SENDSR;	 
		aOpCode 	= `contr			;
		aOperand 	= `imm				;
		aScalar		= {`sendsr, 19'b0}	;
		endLineA						;
	endfunction
	
	